/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */


/**
 * @author Neeraj Joshi <jneeraj@us.ibm.com>
 * This interface represents an argument passed to a method call
 * It used in the DataCollector (while creating a method symbol)
 * and Actuator (while invoking a method) implementations 
 * 
 */
package org.apache.imperius.spl.core;

import org.apache.imperius.spl.parser.exceptions.SPLException;


public interface Argument {

	public abstract String getReferenceTypeName();

	public abstract void setReferenceTypeName(String name);

	public abstract String getName();

	public abstract void setName(String name);

	public abstract TypeInfo getType();

	public abstract void setType(String type) throws SPLException;

	public abstract boolean getIsArray();

	public abstract void setIsArray(boolean a);

	public abstract Object getValue();

	public abstract void setValue(Object value);

}