/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */

/**
 * @author Neeraj Joshi
 * This class holds information about the managed resource instances used by
 * a policy during evaluation
 */
package org.apache.imperius.spl.core;

import java.util.HashMap;
import java.util.Map;

public class InstanceInfo 
{
	// Name of the instance
	private String _instanceName = null;
	// An object referencing the instance
	private Object _instance = null;
	// A map of the form propertyName -> Value for the instance
	private Map _instanceSymbolsMap = new HashMap();
	
	private boolean isCollectInstance=false;
	
	public InstanceInfo() {	}
	
	public InstanceInfo(String name, Object obj)
	{
		_instanceName = name;
		_instance = obj;
	}
	public InstanceInfo(String name, Object obj, boolean collectInstance)
	{
		_instanceName = name;
		_instance = obj;
		isCollectInstance=collectInstance;
	}
	
	public void setInstanceSymbolsMap(Map mp)
	{
		_instanceSymbolsMap = mp;
	}
	
	public Map getInstanceSymbolsMap()
	{
		return _instanceSymbolsMap;
	}

	public Object getInstance() {
		return _instance;
	}

	public void setInstance(Object _instance) {
		this._instance = _instance;
	}

	public String getInstanceName() {
		return _instanceName;
	}

	public void setInstanceName(String name) {
		_instanceName = name;
	}
// Should be removed
	/*public boolean isCollectInstance() {
		return isCollectInstance;
	}

	public void setCollectInstance(boolean isCollectInstance) {
		this.isCollectInstance = isCollectInstance;
	}*/
	

}
