/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
//

/**
 * @author Prashant Baliga <prabalig@in.ibm.com>
 *
 */
package org.apache.imperius.spl.parser.statements.actions.impl;

import java.util.logging.Logger;

import org.apache.imperius.spl.parser.statements.ActionBlock;
import org.apache.imperius.util.SPLLogger;



public abstract class DoubleArgumentActionBlock implements ActionBlock
{
    private static Logger logger = SPLLogger.getSPLLogger().getLogger();
    private static final String sourceClass="DoubleArgumentActionBlock";
    
    
    protected ActionBlock _leftActionBlock;
    
    protected ActionBlock _rightActionBlock;
    
   
    
    public DoubleArgumentActionBlock(ActionBlock a1, ActionBlock a2)
    {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "DoubleArgumentActionBlock");

        _leftActionBlock = a1;
        _rightActionBlock = a2;


        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "DoubleArgumentActionBlock");
 
    }
    
   
    
    public ActionBlock getLeftActionBlock()
    {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "getLeftActionBlock");

        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "getLeftActionBlock");
 
        return _leftActionBlock;
    }
    
    public void setLeftActionBlock(ActionBlock leftActionBlock)
    {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "setLeftActionBlock");

       
        this._leftActionBlock = leftActionBlock;
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "setLeftActionBlock");
        
    }
    
    public ActionBlock getRightActionBlock()
    {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "getRightActionBlock");

        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "getRightActionBlock");
 
        return _rightActionBlock;
    }
    
    public void setRightActionBlock(ActionBlock rightActionBlock)
    {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "setRightActionBlock");

        this._rightActionBlock = rightActionBlock;

        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "setRightActionBlock");
 
    }
    
  
    
}
