/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
//

/**
 * @author Prashant Baliga <prabalig@in.ibm.com>
 *
 */

package org.apache.imperius.spl.parser.statements.actions.impl;

import java.util.List;

import org.apache.imperius.spl.core.Actuator;
import org.apache.imperius.spl.core.Expression;
import org.apache.imperius.spl.parser.compiler.symboltable.SPLSymbolTable;
import org.apache.imperius.spl.parser.exceptions.SPLException;
import org.apache.imperius.spl.parser.factory.BuitInOperationExpressionFactory;
import org.apache.imperius.spl.parser.statements.BasicActionBlock;


public class ExtrinsicMethodInvokeAction implements BasicActionBlock 
{
	Expression _actionExpression = null;
	public ExtrinsicMethodInvokeAction(String methodName, List paramList, SPLSymbolTable sst) throws SPLException
	{
		_actionExpression = 
			BuitInOperationExpressionFactory.createBuiltInAction(
					methodName, paramList, sst);
		
	}

	public boolean execute(Actuator ac) throws SPLException
	{
//		try 
//		{
			_actionExpression.evaluate();
			return true;
//		} 
//		catch (SPLException e) 
//		{
//		}
//		return false;
	}

	//Xiping 06/13/08
	public Expression getActionExpression() {
		return _actionExpression;
	}
}
