/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
//

/**
 * @author Prashant Baliga <prabalig@in.ibm.com>
 *
 */
package org.apache.imperius.spl.parser.statements.impl;

import java.util.logging.Logger;

import org.apache.imperius.spl.core.Expression;
import org.apache.imperius.spl.parser.compiler.symboltable.SPLSymbolTable;
import org.apache.imperius.util.SPLLogger;


public class ConstantDefinition 
{
	private String ident;
	private Expression initExpr;
	private SPLSymbolTable symTab;
	private static Logger logger = SPLLogger.getSPLLogger().getLogger();

    private static final String sourceClass="ConstantDefinition";
    
	
	public String getIdent() {  
        
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "getIdent");
    
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "getIdent");
   
		return ident;
	}

	public void setIdent(String ident) {    
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "setIdent");
    
		this.ident = ident;
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "setIdent");
        
	}

	public SPLSymbolTable getSymTab() {    
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "getSymTab");
    
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "getSymTab");
   
		return symTab;
	}

	public void setSymTab(SPLSymbolTable symTab) {    
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "setSymTab");
    
		this.symTab = symTab;
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "setSymTab");
        
	}

	public Expression getInitExpr() {    
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "getInitExpr");
    
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "getInitExpr");
   
		return initExpr;
	}

	public void setInitExpr(Expression initExpr) {    
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "setInitExpr");
    
		this.initExpr = initExpr;
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "setInitExpr");
        
	}

	public ConstantDefinition(String ident, Expression iExpr, SPLSymbolTable sTab)
	{    
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "ConstantDefinition");
    
		this.ident = ident;
		this.initExpr = iExpr;
		this.symTab = sTab;

        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "ConstantDefinition");
   
	}
}
