/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
//

/**
 * @author Neeraj Joshi <jneeraj@us.ibm.com>
 *
 */
package org.apache.imperius.spl.parser.statements.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;

import org.apache.imperius.spl.core.Expression;
import org.apache.imperius.spl.parser.compiler.symboltable.SPLSymbolTable;
import org.apache.imperius.util.SPLLogger;


public class ImportStatement 
{
	
	private List _importInstanceInfoList;
	private Expression _expr;
	private SPLSymbolTable _symTab;
	private String _anchorClassName;
	private static Logger logger = SPLLogger.getSPLLogger().getLogger();
    private static final String sourceClass="ImportStatement";
    
    
	

	public SPLSymbolTable getSymTab() {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "getSymTab");
        
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "getSymTab");
   
		return _symTab;
	}

	public void setSymTab(SPLSymbolTable symTab) {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "setSymTab");
        
		this._symTab = symTab;
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "setSymTab");
        
	}

	public ImportStatement(String anchorClassName, 
	        List importInstanceInfoList, Expression e,SPLSymbolTable symTab)
	{
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "ImportStatement");
        
		this._anchorClassName = anchorClassName;
		this._expr = e;
		this._symTab = symTab;
		_importInstanceInfoList=new ArrayList(importInstanceInfoList);
// DAW 12/30/2008
//		Iterator it=importInstanceInfoList.iterator();
//		while(it.hasNext())
//		{
//			InstanceInfo iinfo=(InstanceInfo)it.next();
//			//NRJ
//			//if(!iinfo.isCollectInstance())
//			{
//				this._importInstanceInfoList.add(iinfo);
//			}
//			
//			
//		}
		logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "ImportStatement");
        
	}

	
	public Expression getExpr() {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "getExpr");
        
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "getExpr");
   
		return _expr;
	}

	public void setExpr(Expression expr) {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "setExpr");
        
		this._expr = expr;
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "setExpr");
        
	}
	
	public List getImportInstanceInfoList()
	{
		return _importInstanceInfoList;
		
	}

    public String getAnchorClassName()
    {
        return _anchorClassName;
    }

    public void setAnchorClassName(String className)
    {
        _anchorClassName = className;
    }

	

	

	
}
