/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
//

/**
 * @author Neeraj Joshi <jneeraj@us.ibm.com>
 *
 */
package org.apache.imperius.spl.parser.statements.impl;

import java.util.logging.Logger;

import org.apache.imperius.util.SPLLogger;


public class StrategyStatement 
{
	private String strategy;
	private static Logger logger = SPLLogger.getSPLLogger().getLogger();
    private static final String sourceClass="StrategyStatement";
    
	
	public String getStrategy() {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "getStrategy");
        
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "getStrategy");
   
		return strategy;
	}

	public void setStrategy(String strategy) {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "setStrategy");
        
		this.strategy = strategy;
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "setStrategy");
        
	}

	public StrategyStatement(String st)
	{
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "StrategyStatement");
        
		strategy = st;
        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "StrategyStatement");
        
	}
}
