/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
//

/**
 * @author Prashant Baliga <prabalig@in.ibm.com>
 *
 */
package org.apache.imperius.spl.parser.util;

import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.apache.imperius.util.SPLLogger;


public class KeyStringToMapConvertor
{
    private static Logger logger = SPLLogger.getSPLLogger().getLogger();

    private static final String sourceClass="ExpressionUtility";
    
    
    public static Map getMapOfKeys(String keyValues)
    {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "getMapOfKeys");
        
        String keyString = keyValues;
        if(logger.isLoggable(Level.FINE))
            logger.fine(Thread.currentThread().getName()+"keyString "+keyString);
        
        //System.out.println("keyValues " + keyValues);
        keyString = keyString.substring(keyString.indexOf('.') + 1);
        Map keysMap = new HashMap();
        if (keyString.startsWith("&&"))
        {
            keyString = keyString.substring(2);
        }
        while (keyString.indexOf('$') != -1)
        {
            String keyValue = "";
            String keyName = keyString.substring(0, keyString.indexOf('$'));
            //System.out.println(" keyString keyName keyValue " + keyString + " "+ keyName + " " + keyValue);
            if (keyName.indexOf('.') != -1)
            {
                keyName = keyName.substring(keyName.indexOf('.') + 1);
                //System.out.println(" keyString keyName keyValue " + keyString+ " " + keyName + " " + keyValue);
            }
            keyName = keyName.trim().toLowerCase();
            keyString = keyString.substring(keyString.indexOf('$') + 1);
            //System.out.println(" keyString keyName keyValue " + keyString + " "+ keyName + " " + keyValue);
            if (keyString.indexOf("&&") != -1)
            {
                keyValue = keyString.substring(0, keyString.indexOf("&&"));
                //System.out.println(" keyString keyName keyValue " + keyString+ " " + keyName + " " + keyValue);
                keyString = keyString.substring(keyString.indexOf("&&") + 2);
                //System.out.println(" keyString keyName keyValue " + keyString+ " " + keyName + " " + keyValue);
            }
            else
            {
                keyValue = keyString;
                //System.out.println(" keyString keyName keyValue " + keyString+ " " + keyName + " " + keyValue);
                keyString = "";
                //System.out.println(" keyString keyName keyValue " + keyString+ " " + keyName + " " + keyValue);
            }
            //System.out.println(" keyString keyName keyValue " + keyString + " "+ keyName + " " + keyValue);
            //System.out.println("CIMObjectInstance  keyName: "+ keyName.toLowerCase() + "  keyValue : " + keyValue);
            if(logger.isLoggable(Level.FINE))
                logger.fine(Thread.currentThread().getName()+"keyName, keyValue "+keyName+ " , "+ keyValue);
            
            keysMap.put(keyName, keyValue);
        }

        logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "getMapOfKeys");
   
        return keysMap;
    }
    
    public static String KeyStringToClassName(String keyValues)
    {
        logger.entering(sourceClass,Thread.currentThread().getName()+" "+ "KeyStringToClassName");
        
        
        String className = keyValues.substring(0, keyValues.indexOf('.'));
        if (className != null)
        {
            logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "KeyStringToClassName");
            
            return className;
        }
        else
        {
            logger.exiting(sourceClass,Thread.currentThread().getName()+" "+ "KeyStringToClassName");
            
            return null;
        }
    }
}
