/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
/**/
package org.apache.imperius.util;

import java.text.MessageFormat;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class Messages 
{
	private static final String BUNDLE_NAME = "org.apache.imperius.util.messages"; //$NON-NLS-1$
	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
			.getBundle(BUNDLE_NAME);

	private static final MessageFormat formatter = new MessageFormat("");

	
	// Error messages
	public static final String SPLOF0001E = "SPLOF0001E"; //$NON-NLS-1$
	public static final String SPLOF0002E = "SPLOF0002E"; //$NON-NLS-1$
	public static final String SPLOF0003E = "SPLOF0003E"; //$NON-NLS-1$
	public static final String SPLOF0004E = "SPLOF0004E"; //$NON-NLS-1$
	public static final String SPLOF0005E = "SPLOF0005E"; //$NON-NLS-1$
	public static final String SPLOF0006E = "SPLOF0006E"; //$NON-NLS-1$
	public static final String SPLOF0007E = "SPLOF0007E"; //$NON-NLS-1$
	public static final String SPLOF0008E = "SPLOF0008E"; //$NON-NLS-1$
	public static final String SPLOF0009E = "SPLOF0009E"; //$NON-NLS-1$
	
	
	
	// Info messages
	public static final String SPLOF0400I = "SPLOF0400I"; //$NON-NLS-1$
	public static final String SPLOF0401I = "SPLOF0401I"; //$NON-NLS-1$
	public static final String SPLOF0402I = "SPLOF0402I"; //$NON-NLS-1$
	public static final String SPLOF0403I = "SPLOF0403I"; //$NON-NLS-1$
	public static final String SPLOF0404I = "SPLOF0404I"; //$NON-NLS-1$
	public static final String SPLOF0405I = "SPLOF0405I"; //$NON-NLS-1$
	public static final String SPLOF0406I = "SPLOF0406I"; //$NON-NLS-1$
	public static final String SPLOF0407I = "SPLOF0407I"; //$NON-NLS-1$
	public static final String SPLOF0408I = "SPLOF0408I"; //$NON-NLS-1$
	public static final String SPLOF0409I = "SPLOF0409I"; //$NON-NLS-1$
	
	private Messages()
	{
		
	}
	
	public static String getString(String key) 
	{
		try 
		{
			return RESOURCE_BUNDLE.getString(key);
		} 
		catch (MissingResourceException e) 
		{
			return '!' + key + '!';
		}
	}
	
	public static String getString(String key, Object[] params) 
	{
		formatter.applyPattern(RESOURCE_BUNDLE.getString(key));
		String output = formatter.format(params);
		return output;
	}
}
