/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
/**/

/**
 * @author Prashant Baliga <prabalig@in.ibm.com>
 *
 */

package org.apache.imperius.util;

import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.Logger;

class SPLAuditLoggerClass extends Logger
{
    private Logger internalLogger=null;
    
    public SPLAuditLoggerClass(String name, String resourceBundleName)
    {
        
        super(name, resourceBundleName);
        this.internalLogger=Logger.getLogger(name, resourceBundleName);
        // TODO Auto-generated constructor stub
    }
    
    
    synchronized public void addHandler(Handler handler)
    {
        this.internalLogger.addHandler(handler);
    }
   
    synchronized public void setLevel(Level level)
    {
        this.internalLogger.setLevel(level);
    }
    
    synchronized public boolean isLoggable(Level level)
    {
        return internalLogger.isLoggable(level);
    }
    
    synchronized public void fine(String msg)
    {
        String msgActual=Thread.currentThread().getName();
        msgActual+=" "+msg;
        this.internalLogger.fine(msgActual);
        
    }
    
    synchronized public void entering(String className, String msg)
    {
        String msgActual=Thread.currentThread().getName();
        msgActual+=" "+msg;
        this.internalLogger.entering(className, msgActual);
        
    }
    
    synchronized public void exiting(String className, String msg)
    {
        String msgActual=Thread.currentThread().getName();
        msgActual+=" "+msg;
        this.internalLogger.exiting(className, msgActual);
        
    }
    
    synchronized public void severe(String msg)
    {
        String msgActual=Thread.currentThread().getName();
        msgActual+=" "+msg;
        Logger.getAnonymousLogger();
        this.internalLogger.severe(msgActual);
        
    }
    
  /*  public static final Logger getLogger(String name)
    {
        return new SPLLoggerClass(name,null);
        // TODO Auto-generated constructor stub
    }*/
   
 
}
