/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
package org.apache.imperius.javaspl.samples.bugfix;

public class ByteArrayFactory {
	private byte x[];
	private int y;
	
	public ByteArrayFactory(byte[] array) {
		x = array;
	}
	
	public int getByteArray(int b) {
		return b;
	}
	
	public boolean takeByteArray(int barray) {
		return (barray > 0 ? true : false);
	}

	public byte[] getByteArray() {
		return x;
	}

	public byte[] getByteArray(int a1, int a2) {
		x[0] = (byte)a1;
		x[1] = (byte)a2;
		return x;
	}
	
	public boolean takeByteArray(byte[] barray) {
		return (barray[0] + barray[1] > 0 ? true : false);
	}

	public String getByteArray(String s) {
		return s;
	}

	public boolean takeByteArray(String s) {
		return (s.equals("test") ? true : false);
	}

	public boolean takeByteArray(int[] barray) {
		return (barray[0] + barray[1] > 0 ? true : false);
	}

	public int[] getByteArray(double var) {
		int[] xx = new int[2];
		xx[0] = x[0];
		xx[1] = x[1];
		
		return xx;
	}

	public void setValueY(int value) {
		y = value;
	}
}

//public interface ByteArrayFactory {
//	
//	public byte[] getByteArray();
//	
//	public boolean takeByteArray(byte[] barray);
//
//}
