/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
package org.apache.imperius.javaspl.samples.simplepolicies;

import java.util.Calendar;
import java.util.GregorianCalendar;

public class TestElement 
{
    public String ElementName;

    public String s; 
    public char c;
    public double r64;
    public float r32;
    public Calendar d;
    public long s64;
    public int s32;
    public short s16;
    public byte s8;
    public boolean b;
    private int privateVariable;
    private boolean privateBooleanVar = false;
    private SampleClass scObj = new SampleClass(2, 3);
    public SampleClass sampleClassInstance = new SampleClass(5, 10);
    
    public void setPrivateVariable(int s)
    {
        privateVariable = s;
    }
    
    public int getPrivateVariable()
    {
        return privateVariable;
    }

    public String childProperty;
    
    public int testMethod(int a, int b)
    {
        return a + b;
    }
    
    public TestElement()
    {
        ElementName = "Element1";

        s="string5"; 
        c='d';
        r64=54.0;
        r32=54.0f;
        d= new GregorianCalendar();
        s64=-530;
        s32=-530;
        s16=-50;
        s8=-10;
        b=false;
        childProperty="child property5";

        
    }

    public boolean isPrivateBooleanVar() {
        return privateBooleanVar;
    }

    public void setPrivateBooleanVar(boolean privateBooleanVar) {
        this.privateBooleanVar = privateBooleanVar;
    }

    public SampleClass getScObj() {
        return scObj;
    }

    public void setScObj(SampleClass scObj) {
        this.scObj = scObj;
    }


}
