/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.  
 */
package org.apache.imperius.javaspl.samples.simplepolicies;

import junit.extensions.TestSetup;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.apache.imperius.javaspl.samples.bugfix.RunBugFixTest;
import org.apache.imperius.javaspl.samples.simplepolicies.RunSamples;


public class TestSimplePolicies extends TestCase 
{
	
	public TestSimplePolicies(String arg0) {
		super(arg0);
	}

	public static Test suite() {
		TestSuite suite = new TestSuite(TestSimplePolicies.class);
		TestSetup wrapper = new TestSetup(suite) {

			protected void setUp() throws Exception {
				oneTimeSetUp();
			}

			protected void tearDown() throws Exception {
				oneTimeTearDown();
			}
		};
		return wrapper;
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(suite());
	}

	
	protected static void oneTimeSetUp() throws Exception {

	}

	protected static void oneTimeTearDown() throws Exception {

	}
	
	/**
	 * @param args
	 */
	public static void testMain() 
	{
		String userDir = System.getProperty("user.dir");
		System.out.println("user dir is " + userDir);
		RunSamples.test(userDir + "/resources/samples/simple/policies/");
		
		RunBugFixTest.test(userDir + "/resources/samples/bugfix/policies/");
		
	}

}








